# enable_gtkdoc: Toggle if gtkdoc stuff should be rebuilt
#	0 = no
#	1 = yes
%define enable_gtkdoc	0

# gw bootstrap: fam pulls glib2, so build without fam
%define bootstrap 0

# Note that this is NOT a relocatable package
%define api_version	2.0
%define lib_major	0
%define lib_name	%mklibname %{name}_ %{lib_major}
%define libgio_name	%mklibname gio%{api_version}_ %{lib_major}
%define develname	%mklibname -d %name
%define staticname	%mklibname -d -s %name

%define url_ver %(echo %{version}|cut -d. -f1,2)

Summary:   GIMP Toolkit and GIMP Drawing Kit support library
Name:      glib%{api_version}
Version:   2.32.1
Release:   %mkrel 2
License:   LGPLv2+
Group:     System/Libraries
Source0:   http://download.gnome.org/sources/glib/%{url_ver}/glib-%{version}.tar.xz
Source1:   glib20.sh
Source2:   glib20.csh
Patch1:    glib-silence-deprecated-paths.patch
URL:       http://www.gtk.org
Requires:  common-licenses
Requires:  shared-mime-info >= 0.70
%if !%bootstrap
BuildRequires:	fam-devel
%endif
BuildRequires:	libpcre-devel >= 8.11
BuildRequires:	zlib-devel
BuildRequires:  dbus-devel >= 1.2.14
BuildRequires:  gettext
BuildRequires:	libtool
BuildRequires:  locales-en
BuildRequires:  libffi-devel >= 3.0.0
%if %enable_gtkdoc
BuildRequires:	gtk-doc >= 0.10
%endif

#gw this was required since 2.23.2 (new atomic OPs?)
%define _requires_exceptions GLIBC_PRIVATE

%description
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

Glib is used by GDK, GTK+ and many applications.
You should install Glib because many of your applications
will depend on this library.

%package common
Summary: data files used by glib
Group: System/Libraries

%description common
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

This package contains data used by glib library.

%package -n %{lib_name}
Summary: %{summary}
Group: %{group}
Provides:	glib2 = %{version}-%{release}
Provides:	libglib2 = %{version}-%{release}
Provides:	lib%{name} = %{version}-%{release}
Conflicts:  libglib1.3_13

%description -n %{lib_name}
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

Glib is used by GDK, GTK+ and many applications.
You should install Glib because many of your applications
will depend on this library.

This package contains the library needed to run programs dynamically
linked with the glib.

%package -n %{libgio_name}
Summary: GIO is the input, output and streaming API of glib
Group: %{group}
Requires:	%{lib_name} = %{version}
Requires(post):	%{lib_name} = %{version}
Suggests:	%mklibname gvfs 0

%description -n %{libgio_name}
GIO is the input, output and streaming API of glib. It on the one hand
provides a set of various streaming classes to access data from different
sources in a convenient way and on the other hand it provides a high level
file system abstraction to access file and directories not only local but also
on the network. For the latter you need to install gvfs.

%package -n %develname
Summary: Static libraries and header files of %{name}
Group:   Development/C
Provides:	glib2-devel = %{version}-%{release}
Provides:	libglib2-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Requires:	%{lib_name} = %{version}
Requires:	%{libgio_name} = %{version}
Requires:	%{name}-common = %{version}
Requires:	glib-gettextize >= %{version}
Conflicts:  libglib1.3_13-devel
#gw for %{_datadir}/glib-%{api_version}/gdb
Conflicts:  glib-gettextize < 2.25.3
Obsoletes: %mklibname -d %{name}_ 0

%description -n %develname
Header files for the support library for the GIMP's X libraries, which are
available as public libraries. GLIB includes generally useful data structures.

%package -n %staticname
Summary:	Static libraries and header files of %{name}
Group:		Development/C
Requires:	%develname = %{version}-%{release}
Provides:	glib2-static-devel = %{version}-%{release}
Provides:	libglib2-static-devel = %{version}-%{release}
Provides:	lib%{name}-static-devel = %{version}-%{release}
Conflicts:	%develname < 2.28.6-2

%description -n %staticname
Static libraries and files for the support library for the GIMP's X libraries,
which are available as public libraries. GLIB includes generally useful data
structures.

%package -n glib-gettextize
Summary: Gettextize replacement
Group: Development/Other

%description -n glib-gettextize
%{name} package is designed to replace gettextize completely.
Various gettext related files are modified in glib and gtk+ to
allow better and more flexible i18n; however gettextize overwrites
them with its own copy of files, thus nullifying the changes.
If this replacement of gettextize is run instead, then all gnome
packages can potentially benefict from the changes.

%prep
%setup -n glib-%{version} -q
%apply_patches

%build
%configure2_5x \
	--with-pcre=system \
	--enable-static \
	--disable-selinux \
	--with-runtime-libdir=../../%_lib \
%if !%enable_gtkdoc
	--enable-gtk-doc=no
%endif

%make

%check
#gw http://bugzilla.gnome.org/show_bug.cgi?id=440544
#make check

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/50glib20.sh
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/50glib20.csh

%find_lang glib20

mv $RPM_BUILD_ROOT%{_bindir}/gio-querymodules $RPM_BUILD_ROOT%{_bindir}/gio-querymodules-%{__isa_bits}

# automatic gschema compilation on rpm installs/removals 
# (see http://wiki.mandriva.com/en/Rpm_filetriggers) 
install -d %buildroot%{_var}/lib/rpm/filetriggers 
cat > %buildroot%{_var}/lib/rpm/filetriggers/glib-compile-schemas.filter << EOF
^.%_datadir/glib-2.0/schemas/[^/]*\.xml$
^.%_datadir/glib-2.0/schemas/[^/]*\.override$
EOF
cat > %buildroot%{_var}/lib/rpm/filetriggers/glib-compile-schemas.script << EOF
#!/bin/sh
if [ -x /usr/bin/glib-compile-schemas ]; then
  /usr/bin/glib-compile-schemas --allow-any-name %_datadir/glib-2.0/schemas/
fi
EOF
chmod 755 %buildroot%{_var}/lib/rpm/filetriggers/glib-compile-schemas.script 
# automatic update of gio module cache
cat > %buildroot%{_var}/lib/rpm/filetriggers/gio-querymodules.filter << EOF
^.%{_libdir}/gio/modules/*.so$
EOF
cat > %buildroot%{_var}/lib/rpm/filetriggers/gio-querymodules.script <<EOF
#!/bin/sh
%{_bindir}/gio-querymodules-%{__isa_bits} %{_libdir}/gio/modules	 
EOF

#ghost files
touch %buildroot%_libdir/gio/modules/giomodule.cache \
      %buildroot%_datadir/glib-2.0/schemas/gschemas.compiled

# don't ship .a files for gio modules
rm -f %buildroot%_libdir/gio/modules/lib*a

# we don't want these
find %{buildroot} -name "*.la" -delete
rm -f $RPM_BUILD_ROOT%{_datadir}/glib-2.0/gdb/*.{pyc,pyo}

%post -n %{libgio_name}
%if %_lib != lib
 %{_bindir}/gio-querymodules-64 %{_libdir}/gio/modules 
%else
 %{_bindir}/gio-querymodules-32 %{_libdir}/gio/modules
%endif

%files common -f glib20.lang
%doc README
%config(noreplace) %{_sysconfdir}/profile.d/*
%_sysconfdir/bash_completion.d/gdbus-bash-completion.sh
%_sysconfdir/bash_completion.d/gsettings-bash-completion.sh
%_sysconfdir/bash_completion.d/gresource-bash-completion.sh
%{_bindir}/gdbus
%{_bindir}/gresource
%{_bindir}/glib-compile-schemas
%{_bindir}/glib-compile-resources
%{_bindir}/gsettings
%{_mandir}/man1/gio-querymodules.1*
%_mandir/man1/glib-compile-schemas.1*
%_mandir/man1/glib-compile-resources.1*
%_mandir/man1/gsettings.1*
%{_mandir}/man1/gdbus.1*
%{_mandir}/man1/gresource.1*
%dir %_datadir/glib-2.0/
%dir %_datadir/glib-2.0/schemas/
%_datadir/glib-2.0/schemas/gschema.dtd
%ghost %_datadir/glib-2.0/schemas/gschemas.compiled
%{_var}/lib/rpm/filetriggers/glib-compile-schemas.*
%{_var}/lib/rpm/filetriggers/gio-querymodules.*

%files -n %{lib_name}
%doc README
/%{_lib}/libglib-%{api_version}.so.*
/%{_lib}/libgmodule-%{api_version}.so.*
/%{_lib}/libgthread-%{api_version}.so.*
/%{_lib}/libgobject-%{api_version}.so.*

%files -n %{libgio_name}
%_bindir/gio-querymodules-*
/%{_lib}/libgio-%{api_version}.so.*
%dir %_libdir/gio/
%dir %_libdir/gio/modules/
%if !%bootstrap
%_libdir/gio/modules/libgiofam.so
%endif
%ghost %_libdir/gio/modules/giomodule.cache

%files -n %develname
%doc AUTHORS ChangeLog NEWS
%doc %{_datadir}/gtk-doc/html/*
%{_libdir}/lib*.so
%{_libdir}/glib-%{api_version}
%{_libdir}/gdbus-%{api_version}/codegen
%{_libdir}/pkgconfig/*
%{_includedir}/*
%{_mandir}/man1/glib-genmarshal.1*
%{_mandir}/man1/glib-mkenums.1*
%{_mandir}/man1/gobject-query.1*
%{_mandir}/man1/gtester-report.1*
%{_mandir}/man1/gtester.1*
%{_mandir}/man1/gdbus-codegen.1*
%{_datadir}/aclocal/glib-%{api_version}.m4
%{_datadir}/aclocal/gsettings.m4
%{_bindir}/glib-genmarshal
%{_bindir}/glib-mkenums
%{_bindir}/gobject-query
%{_bindir}/gtester*
%{_bindir}/gdbus-codegen
%{_datadir}/gdb/auto-load/%_lib/lib*-gdb.py
%{_datadir}/glib-%{api_version}/gdb

%files -n glib-gettextize
%{_bindir}/glib-gettextize
%_mandir/man1/glib-gettextize.1*
%{_datadir}/aclocal/glib-gettext.m4
%{_datadir}/glib-%{api_version}/gettext

%files -n %staticname
%{_libdir}/lib*.a


%changelog

* Wed Apr 25 2012 ovitters <ovitters> 2.32.1-2.mga2
+ Revision: 233208
- silence deprecated paths message

* Sat Apr 14 2012 ovitters <ovitters> 2.32.1-1.mga2
+ Revision: 230746
- new version 2.32.1

* Sat Mar 24 2012 ovitters <ovitters> 2.32.0-1.mga2
+ Revision: 226066
- new version 2.32.0

* Mon Mar 19 2012 ovitters <ovitters> 2.31.22-1.mga2
+ Revision: 224514
- new version 2.31.22

* Mon Mar 05 2012 wally <wally> 2.31.20-1.mga2
+ Revision: 219097
- new version 2.31.20

* Fri Mar 02 2012 ovitters <ovitters> 2.31.18-1.mga2
+ Revision: 216868
- new version 2.31.18

* Sat Feb 18 2012 ovitters <ovitters> 2.31.16-2.mga2
+ Revision: 210476
- also compile glib schemas when override schema is installed (rpm filetrigger)

* Sun Feb 05 2012 fwang <fwang> 2.31.16-1.mga2
+ Revision: 204545
- new version 2.31.16

* Wed Feb 01 2012 fwang <fwang> 2.31.14-1.mga2
+ Revision: 203810
- update file list
- new version 2.31.14

* Thu Jan 26 2012 fwang <fwang> 2.31.12-5.mga2
+ Revision: 201900
- do not force to use lpthread

* Thu Jan 26 2012 fwang <fwang> 2.31.12-4.mga2
+ Revision: 201808
- foce lpthread for G_THREAD_LIBS

* Mon Jan 23 2012 tv <tv> 2.31.12-3.mga2
+ Revision: 200328
- drop suggests from main lib on common subpackage;
  since basesystem requires systemd that requires libglib,
  we had a whole dep tree that bring in gnome-keyring, gnupg2, dirmnr, colord,
  avahi, gamin & fuse in basesystem...
  let's unbloat this

* Mon Jan 23 2012 dmorgan <dmorgan> 2.31.12-2.mga2
+ Revision: 200180
- Own %%{_libdir}/glib-%%{api_version}

* Sat Jan 21 2012 ovitters <ovitters> 2.31.12-1.mga2
+ Revision: 198964
- new version

* Mon Jan 16 2012 ovitters <ovitters> 2.31.10-1.mga2
+ Revision: 197002
- package new files
- new version

* Tue Jan 10 2012 fwang <fwang> 2.31.8-1.mga2
+ Revision: 194438
- new version 2.31.8

* Mon Dec 19 2011 wally <wally> 2.31.6-1.mga2
+ Revision: 184580
- new version 2.31.6

* Tue Dec 13 2011 fwang <fwang> 2.31.4-1.mga2
+ Revision: 181238
- new version 2.31.4

* Tue Nov 22 2011 fwang <fwang> 2.31.2-1.mga2
+ Revision: 170724
- fix str fmt
- new version 2.31.2

* Tue Nov 08 2011 wally <wally> 2.31.0-2.mga2
+ Revision: 165597
- drop .la files

* Thu Oct 27 2011 wally <wally> 2.31.0-1.mga2
+ Revision: 158649
- new version 2.31.0

* Fri Oct 14 2011 wally <wally> 2.30.1-1.mga2
+ Revision: 155231
- new version 2.30.1

* Tue Sep 27 2011 fwang <fwang> 2.30.0-1.mga2
+ Revision: 149072
- new version 2.30.0

* Sun Sep 18 2011 fwang <fwang> 2.29.92-1.mga2
+ Revision: 145093
- new version 2.29.92

* Fri Sep 16 2011 fwang <fwang> 2.29.90-4.mga2
+ Revision: 144175
- requires /usr/bin/glib-compile-schemas when developing software

* Thu Sep 15 2011 tv <tv> 2.29.90-3.mga2
+ Revision: 143853
- s/requires/suggests/ common subpackage from library one in order to try
  harder not making installing udev ended in installing quite a lot of GNOME
  package (mga#609)
  previous attempt no more work since we now have new auto dependancies

* Wed Sep 14 2011 tv <tv> 2.29.90-2.mga2
+ Revision: 143467
- drop requires on libgio from glib2.0-common that was introduced in order to
  run gio-querymodules-* in  %%post, thus meaning installing udev ended in
  installing quite a lot of GNOME package (mga#609)
  however this is uneeded as those are now called from the gio package itself...

* Tue Sep 06 2011 wally <wally> 2.29.90-1.mga2
+ Revision: 139636
- new version 2.29.90

* Tue Aug 30 2011 fwang <fwang> 2.29.18-1.mga2
+ Revision: 136717
- update file list
- update file list
- new version 2.29.18
- new version 2.29.16
- new version 2.29.14

* Wed Jul 20 2011 fwang <fwang> 2.29.12-1.mga2
+ Revision: 127392
- new version 2.29.12

* Sat Jul 09 2011 cjw <cjw> 2.29.10-1.mga2
+ Revision: 120797
- 2.29.10

* Sun Jul 03 2011 dmorgan <dmorgan> 2.29.8-1.mga2
+ Revision: 117631
- Fix file list
- Fix buildrequires
- New version 2.29.8

* Thu Jun 09 2011 dmorgan <dmorgan> 2.28.8-1.mga2
+ Revision: 102504
- New version 2.28.8

* Fri May 06 2011 ahmad <ahmad> 2.28.6-3.mga1
+ Revision: 95271
- Revert the deleting of .la files, some packages don't build without it

* Thu May 05 2011 ahmad <ahmad> 2.28.6-2.mga1
+ Revision: 95191
- Split static libs in a separate sub-package
- Don't ship .la
- Use %%{__isa_bits} in %%{_bindir}/gio-querymodules-* (less lines in the spec)

* Thu Apr 14 2011 tv <tv> 2.28.6-1.mga1
+ Revision: 85363
- new release

* Thu Apr 07 2011 blino <blino> 2.28.5-2.mga1
+ Revision: 81627
- require libglib for libgio post  (needed for gio-querymodules)

* Sat Apr 02 2011 ahmad <ahmad> 2.28.5-1.mga1
+ Revision: 79751
- update to 2.28.5

* Sun Mar 27 2011 tv <tv> 2.28.4-4.mga1
+ Revision: 77972
- fix biarch install

  + ahmad <ahmad>
    - fix typo in configure options, it's --with-runtime-libdir (Mandriva)

* Sat Mar 26 2011 pterjan <pterjan> 2.28.4-2.mga1
+ Revision: 77863
- Use filetrigger for gio module cache update

* Sat Mar 26 2011 ahmad <ahmad> 2.28.4-1.mga1
+ Revision: 77844
- update to 2.28.4
- move gio-querymodules.1* man page to the common subpackage

* Sat Feb 26 2011 pterjan <pterjan> 2.28.1-1.mga1
+ Revision: 60322
- Update to 2.28.1

* Sun Jan 09 2011 blino <blino> 2.26.1-4.mga1
+ Revision: 2213
- remove old requires/conflicts
- imported package glib2.0

